



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java并发编程（五）-- Java内存模型补充</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java并发编程（五）-- Java内存模型补充</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 21:39:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前面我们已经介绍了：当对象和变量存储到计算机的各个内存区域时，必然会遇到的两个问题及解决方法</p>
<ul><li>共享对象的可见性<code><br /></code>-- 解决方法：使用java volatile关键字</li>
<li>共享对象的竞争现象<code></code><br /> -- 解决方法：使用java synchronized代码块</li></ul>
<p>那么，volatile和 synchronized有什么区别呢？</p>
<h1>volatile和synchronized的区别</h1>
<p>根据JMM的实现，线程在具体执行时，会先拷贝主存数据到线程本地（CPU缓存），操作完成后再把结果从线程本地刷到主存。</p>
<p><strong><code>synchronized</code></strong>关键字解决的是执行控制的问题，它会阻止其它线程获取当前对象的监控锁，这样就使得当前对象中被<code>synchronized</code>关键字保护的代码块无法被其它线程访问，也就无法并发执行。更重要的是，<code>synchronized</code>还会创建一个内存屏障，内存屏障指令保证了所有CPU操作结果都会直接刷到主存中，从而保证了操作的内存可见性，同时也使得先获得这个锁的线程的所有操作，都happens-before于随后获得这个锁的线程的操作。</p>
<p><strong><code>volatile</code></strong>关键字解决的是内存可见性的问题，会使得所有对<code>volatile</code>变量的读写都会直接刷到主存，即保证了变量的可见性。这样就能满足一些对变量可见性有要求而对读取顺序没有要求的需求。</p>
<p>使用<code>volatile</code>关键字仅能实现对原始变量(如boolen、 short 、int 、long等)操作的原子性，但需要特别注意，&nbsp;<code>volatile</code>不能保证复合操作的原子性，即使只是<code>i++</code>，实际上也是由多个原子操作组成：<code>read i; inc; write i</code>，假如多个线程同时执行<code>i++</code>，<code>volatile</code>只能保证他们操作的<code>i</code>是同一块内存，但依然可能出现写入脏数据的情况。</p>
<p>对于<code>volatile</code>关键字，当且仅当满足以下所有条件时可使用：</p>
<ul><li><code>对变量的写入操作不依赖变量的当前值，或者你能确保只有单个线程更新变量的值。</code></li>
<li><code>该变量没有包含在具体其他变量的不变式中</code></li></ul>
<h2>两者的对比</h2>
<ol><li>volatile本质是在告诉jvm当前变量在寄存器（工作内存）中的值是不确定的，需要从主存中读取； synchronized则是锁定当前变量，只有当前线程可以访问该变量，其他线程被阻塞住。</li>
<li>volatile仅能使用在变量级别；synchronized则可以使用在变量、方法、和类级别的</li>
<li>volatile仅能实现变量的修改可见性，不能保证原子性；而synchronized则可以保证变量的修改可见性和原子性</li>
<li>volatile不会造成线程的阻塞；synchronized可能会造成线程的阻塞。</li>
<li>volatile标记的变量不会被编译器优化；synchronized标记的变量可以被编译器优化</li></ol>
<h1>支撑Java内存模型的基础原理</h1>
<h2>指令重排序</h2>
<p>在执行程序时，为了提高性能，编译器和处理器会对指令做重排序。但是，JMM确保在不同的编译器和不同的处理器平台之上，通过插入特定类型的<code>Memory Barrier</code>来禁止特定类型的编译器重排序和处理器重排序，为上层提供一致的内存可见性保证。</p>
<ul><li>编译器优化重排序：编译器在不改变单线程程序语义的前提下，可以重新安排语句的执行顺序。</li>
<li>指令级并行的重排序：如果不存l在数据依赖性，处理器可以改变语句对应机器指令的执行顺序。</li>
<li>内存系统的重排序：处理器使用缓存和读写缓冲区，这使得加载和存储操作看上去可能是在乱序执行。</li></ul>
<h2>数据依赖性</h2>
<p>如果两个操作访问同一个变量，其中一个为写操作，此时这两个操作之间存在数据依赖性。&nbsp;<br />编译器和处理器不会改变存在数据依赖性关系的两个操作的执行顺序，即不会重排序。</p>
<h2>as-if-serial</h2>
<p>不管怎么重排序，单线程下的执行结果不能被改变，编译器、runtime和处理器都必须遵守as-if-serial语义。</p>
<h3>内存屏障（Memory Barrier ）</h3>
<p>前面已经说过，通过内存屏障可以禁止特定类型处理器的重排序，从而让程序按我们预想的流程去执行。内存屏障，又称内存栅栏，是一个CPU指令，基本上它是一条这样的指令：</p>
<ul><li>保证特定操作的执行顺序。</li>
<li>影响某些数据（或则是某条指令的执行结果）的内存可见性。</li></ul>
<p>编译器和CPU能够重排序指令，保证最终相同的结果，尝试优化性能。插入一条Memory Barrier会告诉编译器和CPU：不管什么指令都不能和这条Memory Barrier指令重排序。</p>
<p>Memory Barrier所做的另外一件事是强制刷出各种CPU cache，如一个<code>Write-Barrier</code>（写入屏障）将刷出所有在Barrier之前写入 cache 的数据，因此，任何CPU上的线程都能读取到这些数据的最新版本。</p>
<p>这和java有什么关系？上面java内存模型中讲到的volatile是基于Memory Barrier实现的。</p>
<p>如果一个变量是<code>volatile</code>修饰的，JMM会在写入这个字段之后插进一个<code>Write-Barrier</code>指令，并在读这个字段之前插入一个<code>Read-Barrier</code>指令。这意味着，如果写入一个<code>volatile</code>变量，就可以保证：</p>
<ul><li>一个线程写入变量a后，任何线程访问该变量都会拿到最新值。</li>
<li>在写入变量a之前的写入操作，其更新的数据对于其他线程也是可见的。因为Memory Barrier会刷出cache中的所有先前的写入。</li></ul>
<h2>happens-before</h2>
<p>从jdk5开始，java使用新的JSR-133内存模型，基于happens-before的概念来阐述操作之间的内存可见性。</p>
<p>在JMM中，如果一个操作的执行结果需要对另一个操作可见，那么这两个操作之间必须要存在happens-before关系，这个的两个操作既可以在同一个线程，也可以在不同的两个线程中。</p>
<p>与程序员密切相关的happens-before规则如下：</p>
<ul><li>程序顺序规则：一个线程中的每个操作，happens-before于该线程中任意的后续操作。</li>
<li>监视器锁规则：对一个锁的解锁操作，happens-before于随后对这个锁的加锁操作。</li>
<li>volatile域规则：对一个volatile域的写操作，happens-before于任意线程后续对这个volatile域的读。</li>
<li>传递性规则：如果 A happens-before B，且 B happens-before C，那么A happens-before C。</li></ul>
<p>注意：两个操作之间具有happens-before关系，并不意味前一个操作必须要在后一个操作之前执行！仅仅要求前一个操作的执行结果，对于后一个操作是可见的，且前一个操作按顺序排在后一个操作之前。</p>
<p>参考资料：　<code>　　</code></p>
<pre class="prettyprint linenums"><code>　　<a href="http://www.infoq.com/cn/articles/java-memory-model-1" rel="external nofollow noreferrer">http://www.infoq.com/cn/articles/java-memory-model-1</a></code></pre>
<pre class="prettyprint linenums"><code>　　<a href="https://kzx1025.github.io/2017/04/06/java-memory-model/" rel="external nofollow noreferrer">https://kzx1025.github.io/2017/04/06/java-memory-model/</a></code></pre>
<p>　　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4pn4eq.html">css sprite 调整大张图片中小图标的大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m40d08.html">获取token，绑定微信号，自定义菜单，事件响应demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnzzjd8.html">【转】armeabi和armeabi-v7a</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okwyxl9.html">jquery右下角返回顶部</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x14408.html">神秘链接&lowbar;&lowbar;proto&lowbar;&lowbar;是什么鬼</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgrr38.html">推送消息 相关公司  手机端分享http&colon;&sol;&sol;mob&period;com&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kz2669.html">不显示系统错误对话框SetErrorMode（要学会搜索）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zn0ng9.html">JSON的服务器开发之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg7e048.html">安卓开发中Spinner控件的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z00019.html">kettle介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpgnv79.html">用jquery&plus;Asp&period;Net实现省市二级联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjrm1j9.html">MFC笔记10</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2e4708.html">ReSharper2017&period;3的列对齐、排版格式、列对齐错误的修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlrznl9.html">Mysql生成索引的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm45n49.html">web应用安全权威指南&lpar;文摘&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp23e79.html">linux shell学习三</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jeewll8.html">java map 转 json 自编封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy2rj4m9.html">PHP  表格  post  提交   接受</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44kepnq.html">Application的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90d4w4m8.html">数据库中char、varchar、varchar2、nvarchar之间的关系</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gj740q.html">性能测试四十七：jmeter性能监控工具ServerAgent</a>
			</li>
						<li><a href="https://www.batexi.com/a/q250vgwq.html">论文阅读笔记四：CTPN&colon; Detecting Text in Natural Image with Connectionist Text Proposal Network&lpar;ECCV2016&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv20nj19.html">R2CNN项目部分代码学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjdkn79.html">python爬虫点触验证码的识别思路（图片版）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wnlzrq.html">Echo（）、print（）、print&lowbar;r（）区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxderp09.html">windows server 2012 R2 远程桌面授权模式尚未配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4o7pe9.html">混合编译&period;c&sol;&period;cpp与&period;cu文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/96052d49.html">jquery表单提交的新写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2p4drq.html">linux 出错 &OpenCurlyDoubleQuote;INFO&colon; task xxxxxx&colon; 634 blocked for more than 120 seconds&period;&rdquo;的3种解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjdyx49.html">kafka 备忘</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
